Package: SynMut
Type: Package
Title: SynMut: Designing Synonymously Mutated Sequences with Different
        Genomic Signatures
Version: 1.27.0
Authors@R: c(person("Haogao", "Gu", email = "hggu@connect.hku.hk", role = c("aut", "cre")),
    person("Leo L.M.", "Poon", email = "llmpoon@hku.hk", role = "led"))
Description: 
    There are increasing demands on designing virus mutants with specific dinucleotide or codon composition. 
    This tool can take both dinucleotide preference and/or codon usage bias into account while designing mutants.
    It is a powerful tool for in silico designs of DNA sequence mutants.
License: GPL-2
Encoding: UTF-8
Suggests: BiocManager, knitr, rmarkdown, testthat, devtools, prettydoc,
        glue
VignetteBuilder: knitr
Imports: seqinr, methods, Biostrings, stringr, BiocGenerics
RoxygenNote: 7.1.0
Collate: 'regioned_dna_Class.R' 'codon_mimic.R' 'input_seq.R'
        'codon_random.R' 'codon_to.R' 'dinu_to.R' 'distance_analysis.R'
        'region_related.R' 'seq_random.R' 'zzz.R'
biocViews: SequenceMatching, ExperimentalDesign, Preprocessing
BugReports: https://github.com/Koohoko/SynMut/issues
URL: https://github.com/Koohoko/SynMut
git_url: https://git.bioconductor.org/packages/SynMut
git_branch: devel
git_last_commit: 0bb1b93
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-31
NeedsCompilation: no
Packaged: 2025-11-01 00:33:18 UTC; biocbuild
Author: Haogao Gu [aut, cre],
  Leo L.M. Poon [led]
Maintainer: Haogao Gu <hggu@connect.hku.hk>

## SynMut: Tools for Designing Synonymously Mutated Sequences with Different Genomic Signatures
*Haogao Gu, Leo L.M. Poon*

 <img src="https://raw.githubusercontent.com/Koohoko/Koohoko.github.io/master/SynMut/images/sph_logo.png" alt="drawing" width="200" ALIGN="LEFT" /> 
 
 ##### This work was conducted in School of Public Health, The University of Hong Kong under the supervison of Prof. Leo Poon.

***
[DOI: 10.18129/B9.bioc.SynMut](https://doi.org/doi:10.18129/B9.bioc.SynMut)  
<img border="0" src="https://bioconductor.org/shields/build/devel/bioc/SynMut.svg">

### Introduction

*SynMut* designs synonymous mutants for DNA sequences. 

There are increasing demands on designing virus mutants with specific dinucleotide or codon composition. This tool can take both dinucleotide preference and/or codon usage bias into account while designing mutants. It also works well for desinging mutants with extremely over-/under- represented dinucleotides. 

This tool was originally designed for generating recombinant virus sequences in influenza A virus to study the effects of different dinucleotide usage and codon usage, yet the functions provided in this package can be generic to a variety of other biological researches.

### Components of the package

![image](https://raw.githubusercontent.com/Koohoko/Koohoko.github.io/master/SynMut/images/component.png)

### Installation 
Use the below code to install the package.

```r
# Stable version
if (!requireNamespace("BiocManager"))
    install.packages("BiocManager")

if (!requireNamespace("SynMut"))
    BiocManager::install("SynMut")

# Development version
if (!requireNamespace("devtools"))
    install.packages("devtools")

if (!requireNamespace("SynMut"))
    devtools::install_github("Koohoko/SynMut")
```

### Example and methods

Details tutorial please refer to the [vignette](https://koohoko.github.io/SynMut/index.html).

The strategies and functionalities of the `codom_mimic` and `dinu_to` functions can be found at [here](https://koohoko.github.io/SynMut/algorithm.html).

### Find it at Bioconductor
https://bioconductor.org/packages/devel/bioc/html/SynMut.html
***

### Changelog
Changes in version 1.1.5 (2022-06-03)
+ Enhancement: add other non-standard genetic codes for functions codon_random, dinu_to, codon_mimic.

Changes in version 1.1.4 (2020-11-12)
+ bug fix: fix for function codon_mimic.

Changes in version 1.1.3 (2019-05-08)
+ Revise dinu_to.keep algorithm, enhance performance.

Changes in version 1.1.2 (2019-05-08)
+ Bug fix: "dinu_to" ifelse issue in get_optimal_codon.

Changes in version 1.1.1 (2019-05-06)
+ Bug fix: "dinu_to" fix wrong result with "keep == TRUE" parameter.

#' Mimic a target codon usage bias
#'
#' Mutating the current DNA sequences in the regioned_dna object to mimic a
#' target codon usage pattern.
#'
#' @param object regioned_dna object
#' @param alt target codon usage vector or DNAStringSet object representing
#'   target codon usage
#' @param numcode The ncbi genetic code number for translation. Default value: \code{1}. Details please refer to \code{?seqinr::translate} ("https://rdrr.io/cran/seqinr/man/translate.html").
#' @param ... ...
#'
#' @details The ideas for \code{codon_mimic} is similar to
#'   \code{\link{codon_to}}: first extract the mutable regions and then do the
#'   mutation. However the codons in the fixed (not mutable) regions will also
#'   alter the final codon usage, thus we have to adjust for the fixed codons
#'   when introducing sysnonymous codons. The ideal deisgn for
#'   \code{codon_mimic} is not unique as the swap between positions of the
#'   synonymous codons will not change the codon usage bias.
#'
#'   Details pleas refer to: https://koohoko.github.io/SynMut/algorithm.html
#'
#' @return regioned_dna
#' @exportMethod codon_mimic
#' @include regioned_dna_Class.R
#' @seealso \code{\link{input_seq}}, \code{\link{codon_to}},
#'   \code{\link{codon_random}}, \code{\link{dinu_to}}
#' @examples
#' filepath <- system.file("extdata", "example.fasta", package = "SynMut")
#' rgd.seq <- input_seq(filepath)
#' target <- get_cu(rgd.seq)[2,]
#' new <- codon_mimic(rgd.seq, alt = target)
#' get_cu(new) - get_cu(rgd.seq)
#'
#' target <- Biostrings::DNAStringSet("TTGAAAA-CTC-N--AAG")
#' new <- codon_mimic(rgd.seq, alt = target)
#' get_cu(new) - get_cu(rgd.seq)
#' get_freq(new) - get_freq(rgd.seq)
#' get_rscu(new) - get_rscu(rgd.seq)
#' @importFrom Biostrings oligonucleotideFrequency
#' @import methods
#' @import Biostrings
#' @name codon_mimic
#' @rdname codon_mimic-methods
setGeneric(
    name = "codon_mimic",
    def = function(object, alt, numcode = 1, ...) standardGeneric("codon_mimic")
)

#' @rdname codon_mimic-methods
setMethod(
    f = "codon_mimic",
    signature = signature(object = "regioned_dna", alt = "vector"),
    definition = function(object, alt, numcode) {
        if (length(alt) != 64) {
            stop("The length of the target codon usage must be 64")
        }
        alt <- as.numeric(alt)
        names(alt) <- sort(names(GENETIC_CODE))
        result <-
            codon.mimic(alt, dna.seq = object@dnaseq, region = object@region, numcode)
        return(result)
    }
)

#' @rdname codon_mimic-methods
setMethod(
    f = "codon_mimic",
    signature = signature(object = "regioned_dna", alt = "DNAStringSet"),
    definition = function(object, alt, numcode) {
        if (length(alt) > 1) {
            warning("only the first one sequence in the the target was used")
        }
        cu.target <- oligonucleotideFrequency(alt, width = 3, step = 3)[1, ]
        result <- codon.mimic(cu.target,
            dna.seq = object@dnaseq,
            region = object@region,
            numcode)
        return(result)
    }
)

#' @rdname codon_mimic-methods
setMethod(
    f = "codon_mimic",
    signature = signature(object = "DNAStringSet", alt = "DNAStringSet"),
    definition = function(object, alt, numcode) {
        if (length(alt) > 1) {
            warning("only the first one sequence in the the target was used")
        }
        cu.target <- oligonucleotideFrequency(alt, width = 3, step = 3)[1, ]
        object <- input_seq(object)
        result <- codon.mimic(cu.target,
            dna.seq = object@dnaseq,
            region = object@region,
            numcode)
        return(result)
    }
)

codon.mimic <- function(cu.target, dna.seq, region, numcode) {
    check.region <- all(is.na(region))
    seq <- convert_to_seq(dna.seq)
    if (!check.region) {
        #have region
        seq.mut <- codon.mimic.region(cu.target, dna.seq, region, numcode)
    } else {
        #no restriction of region
        seq.mut <- codon.mimic.no.region(cu.target, dna.seq, region, numcode)
    }
    # merge region ------------------------------------------------------------

    if (!check.region) {
        seq.mut <- mapply(function(x, y, z) {
            x[y] <- z
            return(x)
        }, seq, region, seq.mut, SIMPLIFY = FALSE)
    }
    seq.mut <- DNAStringSet(unlist(lapply(seq.mut, c2s)))
    return(new("regioned_dna",
        dnaseq = seq.mut,
        region = region))
}


# helper function -------------------------------------------------------

codon.count <- function(x, numcode) {
    gen_code <- sapply(names(GENETIC_CODE), function(x){
        seqinr::translate(strsplit(x, "")[[1]], numcode = numcode)
    })
    gen_code <- gen_code[order(names(gen_code))]
    base::split(x, gen_code)
}

freq <- function(x, numcode) {
    lapply(codon.count(x, numcode), function(x) {
        x / sum(x)
    })
}

mut.assign.back <- function(seq.region, mut.need, numcode){
    seq.mut <- lapply(seq_along(seq.region), function(i) {
        seq.tmp <- seq.region[[i]]
        seq.tmp.aa <- seqinr::translate(s2c(c2s(seq.tmp)), numcode = numcode)
        aa.names <- names(table(seq.tmp.aa))
        mut.need.tmp <- mut.need[[i]]
        for (j in seq_along(aa.names)) {
            for.sample <- as.character(which(seq.tmp.aa == aa.names[j]))
            pos.tmp <- as.numeric(sample(for.sample))
            mut.cd.tmp <- round(mut.need.tmp[[aa.names[j]]])
            if (!any(is.na(mut.cd.tmp)) & any(mut.cd.tmp>1)) {
                suppressWarnings(seq.tmp[pos.tmp] <-
                        rep(names(mut.cd.tmp), mut.cd.tmp))
            }
        }
        return(seq.tmp)
    })
}

codon.mimic.region <- function(cu.target, dna.seq, region, numcode){
    seq <- convert_to_seq(dna.seq)
    seq.region <- mapply(function(x, y) {
        return(x[y])
    }, seq, region, SIMPLIFY = FALSE)
    seq.fixed <- mapply(function(x, y) {
        return(x[!y])
    }, seq, region, SIMPLIFY = FALSE)

    cu.fixed <- get_cu(DNAStringSet(unlist(lapply(seq.fixed, c2s))))
    cu.ori <- get_cu(dna.seq)
    freq.target <- freq(cu.target, numcode)

    mut.need <- lapply(seq_along(seq), function(i) {
        count.ori <- codon.count(cu.ori[i,], numcode)
        count.fixed <- codon.count(cu.fixed[i,], numcode)
        mut.usage <- mapply(function(x, y) {
            sum(x) * y
        }, count.ori, freq.target, SIMPLIFY = FALSE)
        mut.need <- mapply(function(x, y) {
            x - y
        }, mut.usage, count.fixed, SIMPLIFY = FALSE)
        mut.need <- lapply(mut.need, function(x) {
            #fix the negative needs
            x.negative <- x[x < 0]
            x.positive <- x[x > 0]
            if (length(x.negative) > 0) {
                return((1 + sum(abs(
                    x.negative
                )) / sum(x.positive)) * x.positive)
            } else{
                return(x)
            }
        })
    })
    seq.mut <- mut.assign.back(seq.region, mut.need, numcode)
    names(seq.mut) <- names(seq.region)
    return(seq.mut)
}

codon.mimic.no.region <- function(cu.target, dna.seq, region, numcode){
    seq.region <- convert_to_seq(dna.seq)
    freq.target <- freq(cu.target, numcode)

    seq.mut <- lapply(seq_along(seq.region), function(i) {
        seq.tmp <- seq.region[[i]]
        seq.tmp.aa <- seqinr::translate(s2c(c2s(seq.tmp)), numcode=numcode)
        # print(numcode)
        aa.names <- names(table(seq.tmp.aa))
        for (j in seq_along(aa.names)) {
            for.sample <- as.character(which(seq.tmp.aa == aa.names[j]))
            pos.tmp <- as.numeric(sample(for.sample))
            mut.cd.tmp <- round(length(pos.tmp) * freq.target[[aa.names[j]]])
            if (!any(is.na(mut.cd.tmp))) {
                suppressWarnings(seq.tmp[pos.tmp] <-
                        rep(names(mut.cd.tmp), mut.cd.tmp))
            }
        }
        return(seq.tmp)
    })
    names(seq.mut) <- names(seq.region)

    return(seq.mut)
}

# dinu_dist ---------------------------------------------------------------

#' Calculating the dinucleotide usage difference between sequences
#'
#' We use a least squares approach to estimate the dinucleotide usage
#' difference between DNA sequences
#'
#' @param seq the input DNA sequnece of \code{DNAStringSet} or
#'   \code{regioned_dna} class.
#' @param ref the reference DNA sequnece of \code{DNAStringSet} or
#'   \code{regioned_dna} class.
#'
#' @return vector
#'
#' @details similar method that applied in "Daniel Macedo de Melo Jorge, Ryan E.
#'   Mills, Adam S. Lauring, CodonShuffle: a tool for generating and analyzing
#'   synonymously mutated sequences, Virus Evolution, Volume 1, Issue 1, March
#'   2015, vev012, https://doi.org/10.1093/ve/vev012"
#'
#' @exportMethod dinu_dist
#'
#' @examples
#' filepath <- system.file("extdata", "example.fasta", package = "SynMut")
#' rgd.seq <- input_seq(filepath)
#' get_cu(rgd.seq)
#'
#' mut.seq <- codon_random(rgd.seq)
#' dinu_dist(mut.seq, rgd.seq)
#' @name dinu_dist
#' @rdname dinu_dist-methods
setGeneric(
    name = "dinu_dist",
    def = function(seq, ref) standardGeneric("dinu_dist")
)

#' @rdname dinu_dist-methods
setMethod(
    f = "dinu_dist",
    signature = signature("ANY"),
    definition = function(seq, ref) {
        seq.du.freq <- apply(get_du(seq), 1, function(x) {
            x / sum(x)
        })
        ref.du.freq <- apply(get_du(ref), 1, function(x) {
            x / sum(x)
        })
        check <-
            all(ncol(seq.du.freq) != ncol(ref.du.freq),
                ncol(ref.du.freq) != 1)
        if (check) {
            stop(
                "the length of the reference sequences should be
                1. of the same length as the input sequences OR 2. of length 1"
            )
        }
        if (ncol(ref.du.freq) == 1) {
            du.diff <- sweep(seq.du.freq, 1, ref.du.freq, "-")
        } else {
            du.diff <- seq.du.freq - ref.du.freq
        }

        du.dist <- apply(du.diff, 2, function(x) {
            sqrt(mean(x * x))
        })
        return(du.dist)
    }
)


# codon_dist --------------------------------------------------------------
#' Calculating the codon usage difference between sequences
#'
#' We use a least squares approach to estimate the codon usage
#' difference between DNA sequences.
#'
#' @param seq the input DNA sequnece of \code{DNAStringSet} or
#'   \code{regioned_dna} class.
#' @param ref the reference DNA sequnece of \code{DNAStringSet} or
#'   \code{regioned_dna} class.
#'
#' @return vector
#'
#' @details idea inspired by "Daniel Macedo de Melo Jorge, Ryan E.
#'   Mills, Adam S. Lauring, CodonShuffle: a tool for generating and analyzing
#'   synonymously mutated sequences, Virus Evolution, Volume 1, Issue 1, March
#'   2015, vev012, https://doi.org/10.1093/ve/vev012"
#'
#' @exportMethod codon_dist
#'
#' @examples
#' filepath <- system.file("extdata", "example.fasta", package = "SynMut")
#' rgd.seq <- input_seq(filepath)
#' get_cu(rgd.seq)
#'
#' mut.seq <- codon_random(rgd.seq)
#' codon_dist(mut.seq, rgd.seq)
#' mut.seq2 <- codon_random(rgd.seq, keep = TRUE)
#' codon_dist(mut.seq2, rgd.seq)
#' @name codon_dist
#' @rdname codon_dist-methods
setGeneric(
    name = "codon_dist",
    def = function(seq, ref) standardGeneric("codon_dist")
)

#' @rdname codon_dist-methods
setMethod(
    f = "codon_dist",
    signature = "ANY",
    definition = function(seq, ref) {
        seq.cu.freq <- get_freq(seq)
        ref.cu.freq <- get_freq(ref)
        check <-
            all(nrow(seq.cu.freq) != nrow(ref.cu.freq),
                nrow(ref.cu.freq) != 1)
        if (check) {
            stop("the length of the reference sequences should be
            1. of the same length as the input sequences OR 2. of length 1"
            )
        }
        if (nrow(ref.cu.freq) == 1) {
            cu.diff <- sweep(seq.cu.freq, 2, ref.cu.freq, "-")
        } else {
            cu.diff <- seq.cu.freq - ref.cu.freq
        }

        aa.list <- seqinr::ucoweight("")
        aa.list <- aa.list[names(aa.list) != "*"]

        cu.dist <- vapply(aa.list, function(x) {
            cd.name.tmp <- toupper(names(x))
            if (length(cd.name.tmp) == 1) {
                cu.diff.sub <-
                    cu.diff[, toupper(colnames(cu.diff)) %in% cd.name.tmp]
                return(cu.diff.sub)
            } else {
                cu.diff.sub <-
                    cu.diff[, toupper(colnames(cu.diff)) %in% cd.name.tmp]
                if (is.null(nrow(cu.diff.sub))) {
                    rslt <- sqrt(mean(cu.diff.sub * cu.diff.sub))
                } else {
                    rslt <- apply(cu.diff.sub, 1, function(x) {
                        sqrt(mean(x * x))
                    })
                }
                return(rslt)
            }
        }, numeric(nrow(cu.diff)))

        if (is.null(nrow(cu.dist))) {
            return(mean(cu.dist))
        } else {
            return(rowMeans(cu.dist))
        }

    }
)

#' Maximize or minimize the usage of certain codon.
#'
#' Input string of a codon to either the "max.codon = " or "min.codon = "
#' parameter to maximize or minimize the usage of certain codon in the sequence.
#'
#' @param object A regioned_dna object.
#' @param max.codon A string of a codon.
#' @param min.codon A string of a codon.
#' @param ... ...
#'
#' @details The ideas for this function is simple. We first extract the mutable
#'   regions for every sequences, then mutated the synonymous codons of the
#'   input to the desired. There will be only one ideal design for the
#'   maximization problem, however there may be numerous comparable designs
#'   having the same minimal usage of certain codon, as we randomly sample
#'   synonymous codon for substitution when solving the minimization problem.
#'
#' @return A regioned_dna object.
#' @seealso \code{\link{input_seq}}, \code{\link{dinu_to}},
#'   \code{\link{codon_random}}, \code{\link{codon_mimic}}
#' @examples
#' filepath <- system.file("extdata", "example.fasta", package = "SynMut")
#' rgd.seq <- input_seq(filepath)
#' get_cu(codon_to(rgd.seq, max.codon = "AAC")) - get_cu(rgd.seq)
#' get_cu(codon_to(rgd.seq, min.codon = "AAC")) - get_cu(rgd.seq)
#'
#' @exportMethod codon_to
#' @name codon_to
#' @rdname codon_to-methods
#' @import methods
#' @import Biostrings
#' @include regioned_dna_Class.R
setGeneric(
    name = "codon_to",
    def = function(object, max.codon = NA, min.codon = NA,
                   ...) standardGeneric(f = "codon_to")
)


#' @rdname codon_to-methods
setMethod(
    f = "codon_to",
    signature = "regioned_dna",
    definition = function(object, max.codon, min.codon) {
        max.codon <- toupper(max.codon)
        min.codon <- toupper(min.codon)
        codon.input <- c(max.codon, min.codon)
        codon.input <- codon.input[!is.na(codon.input)]
        if (length(codon.input) == 0) {
            stop("please specify at least one parameter of
            'max.codon' or 'min.codon'")
        }
        if (all(!is.na(c(max.codon, min.codon)))) {
            stop("Only one parameter is supported between
            'max.codon' and 'min.codon'")
        }
        if (length(codon.input) > 2) {
            stop("Only one codon is allowed for input in
            'max.codon' or 'min.codon'")
        }
        check.valid.codon <-
            toupper(codon.input) %in% names(GENETIC_CODE)
        if (!check.valid.codon) {
            stop("Please input valid DNA codon")
        }

        # extract region ------------------------------------------------------

        check.region <- all(is.na(object@region))
        seq <- convert_to_seq(object@dnaseq)
        seq.region <- extract_region(object, check.region)

        # do mutation ---------------------------------------------------------

        if (!is.na(max.codon)) {
            max.aa <- as.character(translate(DNAString(max.codon)))
            seq.region.aa <- lapply(seq.region, function(x) {
                seqinr::translate(s2c(c2s(x)))
            })
            id <- lapply(seq.region.aa, function(x) {
                which(x == max.aa)
            })
            seq.mut <- mapply(function(x, y) {
                if (length(y) > 0) {
                    x[y] <- toupper(max.codon)
                }
                return(x)
            }, seq.region, id, SIMPLIFY = FALSE)
        } else {
            min.aa <- as.character(translate(DNAString(min.codon)))
            seq.region.aa <- lapply(seq.region, function(x) {
                seqinr::translate(s2c(c2s(x)))
            })
            id <- lapply(seq.region.aa, function(x) {
                which(x == min.aa)
            })
            alt.codon <- toupper(syncodons(min.codon)[[1]])
            alt.codon <- alt.codon[!(alt.codon == min.codon)]
            seq.mut <- mapply(function(x, y) {
                if (length(y) > 0) {
                    x[y] <- toupper(sample(alt.codon, length(y), replace = T))
                }
                return(x)
            }, seq.region, id, SIMPLIFY = FALSE)
        }

        # merge region --------------------------------------------------------

        seq.mut <- region_back(seq.mut, check.region, seq, object)

        return(new(
            "regioned_dna",
            dnaseq = seq.mut,
            region = object@region
        ))
    }
)

## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----echo=FALSE, message = FALSE----------------------------------------------
url <- paste0("https://raw.githubusercontent.com/Koohoko/Koohoko.github.io/",
  "master/SynMut/images/component.png")

## ----eval=FALSE---------------------------------------------------------------
# if (!requireNamespace("BiocManager"))
#     install.packages("BiocManager")
# if (!requireNamespace("SynMut"))
#     BiocManager::install("SynMut")

## ----message=FALSE------------------------------------------------------------
library("SynMut")
filepath.fasta <- system.file("extdata", "example.fasta", package = "SynMut")
filepath.csv <- system.file("extdata", "target_regions.csv", package = "SynMut")
region <- read.csv(filepath.csv)

## -----------------------------------------------------------------------------
rgd.seq <- input_seq(filepath.fasta, region)
rgd.seq

## -----------------------------------------------------------------------------
get_dna(rgd.seq)

## -----------------------------------------------------------------------------
str(get_region(rgd.seq))
get_region(input_seq(filepath.fasta))

## -----------------------------------------------------------------------------
get_cu(rgd.seq)
get_du(rgd.seq)
get_nu(rgd.seq)

## -----------------------------------------------------------------------------
# Random synonymous mutations
mut.seq <- codon_random(rgd.seq)
# Compare the codon usage
get_cu(mut.seq) - get_cu(rgd.seq)

# Keeping the original codon usage pattern
mut.seq <- codon_random(rgd.seq, keep = TRUE)
# Compare the codon usage
get_cu(mut.seq) - get_cu(rgd.seq)

## -----------------------------------------------------------------------------
# Fifty percent of the codons were allowed for mutation
mut.seq <- codon_random(rgd.seq, n = 0.5)
# Compare the codon usage
get_cu(mut.seq) - get_cu(rgd.seq)

## -----------------------------------------------------------------------------
# Generate AAC-maximized mutations
mut.seq <- codon_to(rgd.seq, max.codon = "AAC")
# Compare the codon usage
get_cu(mut.seq) - get_cu(rgd.seq)

# Generate AAC-minimized mutations
mut.seq <- codon_to(rgd.seq, min.codon = "AAC")
# Compare the codon usage
get_cu(mut.seq) - get_cu(rgd.seq)

## -----------------------------------------------------------------------------
# Maximaize the usage of "CG" dinucleotide in the pre-defined region
mut.seq <- dinu_to(rgd.seq, max.dinu = "cg")
# Check the dinucelotide usage difference between the mutant and the original
get_du(mut.seq) - get_du(rgd.seq)

# Minimize the usage of "CA", and compare the dinucleotide usage.
mut.seq <- dinu_to(rgd.seq, min.dinu = "CA")
get_du(mut.seq) - get_du(rgd.seq)

# Maximize the usage of "CG" while keeping the original codon usage
mut.seq <- dinu_to(rgd.seq, max.dinu = "cg", keep = TRUE)
# Compare the dinucleotide usage
get_du(mut.seq) - get_du(rgd.seq)
# Compare the codon usage
get_cu(mut.seq) - get_cu(rgd.seq)


## -----------------------------------------------------------------------------
# Use a codon usage vector as a target
target <- get_cu(rgd.seq)[2,]
mut.seq <- codon_mimic(rgd.seq, alt = target)
# Compare the codon usage
get_cu(mut.seq) - get_cu(rgd.seq)

# Use a sequence as a target
target <- Biostrings::DNAStringSet("TTGAAAA-CTC-N--AAG")
mut.seq <- codon_mimic(rgd.seq, alt = target)
# Compare the codon usage
get_cu(mut.seq) - get_cu(rgd.seq)
# Compare the synonymous codon usage frequency
get_freq(mut.seq) - get_freq(rgd.seq)
# Compare the Relative Synonymous Codon Usage (RSCU)
get_rscu(mut.seq) - get_rscu(rgd.seq)


## ----eval = FALSE-------------------------------------------------------------
# Biostrings::writeXStringSet(get_dna(rgd.seq), "rgd.fasta")

## -----------------------------------------------------------------------------
sessionInfo()

#' Generate \code{n} random DNA sequnces of length \code{m}
#'
#' Generate \code{n} random DNA sequnces of length \code{m}, optional exclude
#' stop codons.
#'
#' @param n the number of the output sequence(s).
#' @param m the length of the ouput sequence(s). Eighter a fixed number or a
#'   vector of different numbers.
#' @param no.stop.codon Default FALSE. If TRUE, the stop codons in the frame 1
#'   would be substituted to another random codon.
#' @param ... ...
#'
#' @return a DNAStringSet object
#' @exportMethod seq_random
#'
#' @examples
#' seq_random(n = 1, m = 99)
#' seq_random(n = 10, m = 30)
#' seq_random(n = 10, m = 1:10)
#' seq.nsc <- seq_random(n = 10, m = 100, no.stop.codon = TRUE)
#' get_cu(seq.nsc)
#' @name seq_random
#' @import Biostrings
#' @rdname seq_random-methods
setGeneric(
    name = "seq_random",
    def = function(n = 1, m, no.stop.codon = FALSE,
                   ...) standardGeneric("seq_random")
)

#' @rdname seq_random-methods
setMethod(
    f = "seq_random",
    signature = signature(n = "numeric", m = "numeric"),
    definition = function(n, m, no.stop.codon) {
        check.m.length <- length(m) == 1
        if (check.m.length) {
            tmp <- vapply(seq_len(n), function(x) {
                paste0(sample(
                    x = c("a", "t", "g", "c"),
                    size = m,
                    replace = TRUE
                ), collapse = "")
            }, character(1))
        } else {
            tmp <- mapply(function(x, y) {
                paste0(sample(
                    x = c("a", "t", "g", "c"),
                    size = y,
                    replace = TRUE
                ), collapse = "")
            }, seq_len(n), m)
        }
        if (no.stop.codon) {
            stop.codons <- c("taa", "tga", "tag")
            ok.codons <- setdiff(mkAllStrings(c("a", "t", "c", "g"), 3),
                                 stop.codons)
            tmp <- vapply(tmp, function(x) {
                sst <- strsplit(x, "")[[1]]
                if (length(sst) %% 3 != 0) {
                    mut.length <- floor(length(sst) / 3) * 3
                    sst.mut <- sst[seq_len(mut.length)]
                    sst.tail <- sst[(mut.length + 1):length(sst)]
                } else{
                    sst.mut <- sst
                    sst.tail <- ""
                }
                codons <- paste0(sst.mut[c(TRUE, FALSE, FALSE)],
                    sst.mut[c(FALSE, TRUE, FALSE)],
                    sst.mut[c(FALSE, FALSE, TRUE)])
                stop.id <- which(codons %in% stop.codons)
                if (length(stop.id) > 0) {
                    codons[stop.id] <- vapply(seq_along(stop.id), function(x) {
                        sample(ok.codons, size = 1)
                    }, character(1))
                    return(paste0(
                        paste0(codons, collapse = ""),
                        sst.tail,
                        collapse = ""
                    ))
                } else {
                    return(x)
                }
            }, character(1), USE.NAMES = FALSE)
        }
        DNAStringSet(tmp)
    }
)

#' Import region / constructing regioned_dna object
#'
#' Constructing \code{regioned_dna} from DNAStringSet. Optionally input a
#' \code{region} data.frame to define restricted amino-acid region for mutation.
#'
#' @param object Filepath or DNAstringSet. The input sequences is suggested to
#'   be in open reading frame(ORF).
#' @param region \code{NA}. A data.frame specifying paticular regions (positions
#'   in amino acid sequence) that is allowed to be mutated in the sequences.
#'   Both \code{1 / 0} or \code{TRUE / FALSE} encoding is OK. Please refer to
#'   Examples below for reference.
#' @param ... ...
#' @return A regioned_dna-class object
#' @seealso \code{\link{get_cu}}, \code{\link{get_du}},
#'   \code{\link{get_region}}, \code{\link{get_dna}}
#' @examples
#' # Creating a input_seq class directly from system file
#' filepath <- system.file("extdata", "example.fasta", package = "SynMut")
#' rgd.seq <- input_seq(filepath)
#'
#' # Optionally input with region dataframe
#' filepath.fasta <- system.file("extdata", "example.fasta", package = "SynMut")
#' fp.csv <- system.file("extdata", "target_regions.csv", package = "SynMut")
#' region <- read.csv(fp.csv)
#' rgd.seq <- input_seq(filepath.fasta, region)
#'
#' # Creating from exsisting DNAStringSet object
#' seq <- Biostrings::DNAStringSet("ATCGATCGA")
#' rgd.seq <- input_seq(seq)
#'
#' @name input_seq
#' @rdname input_seq-methods
#' @import methods
#' @import BiocGenerics
#' @exportMethod input_seq
setGeneric(
    name = "input_seq",
    def = function(object, region = NA, ...) standardGeneric("input_seq")
)

#' @importFrom Biostrings readDNAStringSet
#' @importFrom Biostrings DNAStringSet
#' @importFrom Biostrings oligonucleotideFrequency
#' @rdname input_seq-methods
setMethod(
    f = "input_seq",
    signature = signature(object = "character"),
    definition = function(object, region) {
        dnaseq <- readDNAStringSet(filepath = object)
        dnaseq <-
            append(dnaseq, DNAStringSet('atg')) #helper sequence
        gernerate_rgd(dnaseq, region)
    }
)

#' @rdname input_seq-methods
setMethod(
    f = "input_seq",
    signature = signature(object = "DNAStringSet"),
    definition = function(object, region) {
        dnaseq <-
            append(object, DNAStringSet('atg')) #helper sequence
        gernerate_rgd(dnaseq, region)
    }
)

#' @rdname input_seq-methods
setMethod(
    f = "input_seq",
    signature = signature(object = "DNAString"),
    definition = function(object, region) {
        dnaseq <- #helper sequence
            append(DNAStringSet(object), DNAStringSet('atg'))
        gernerate_rgd(dnaseq, region)
    }
)


# helper function ---------------------------------------------------------

gernerate_rgd <- function(dnaseq, region){
    if (all(is.na(region))) {
        return(new(
            "regioned_dna",
            dnaseq = dnaseq,
            region = list(NA)
        ))
    } else {
        if (!is(region, "data.frame")) {
            stop("the region input must be in data.frame format")
        }
        region <- as.list(region)
        region <-
            lapply(region, function(x) {
                as.logical(x[!is.na(x)])
            })
        return(new(
            "regioned_dna",
            dnaseq = dnaseq,
            region = c(region, list(TRUE))
        ))
    }
}

# helper function ---------------------------------------------------------

convert_to_seq <- function(dna.seq){
    seq <- lapply(as.character(dna.seq), function(x) {
        splitseq(s2c(x))
    })
    return(seq)
}

extract_region <- function(object, check.region){
    if (!check.region) {
        seq <- convert_to_seq(object@dnaseq)
        seq.region <- mapply(function(x, y) {
            return(x[y])
        }, seq, object@region, SIMPLIFY = FALSE)
    } else {
        seq.region <- lapply(as.character(object@dnaseq),
            function(x) {
                splitseq(s2c(x))
            })
    }
    return(seq.region)
}

region_back <- function(seq.mut, check.region, seq, object){
    if (!check.region) {
        seq.mut <- mapply(function(x, y, z) {
            x[y] <- z
            return(x)
        }, seq, object@region, seq.mut, SIMPLIFY = FALSE)
    }
    seq.mut <- Biostrings::DNAStringSet(unlist(lapply(seq.mut, c2s)))
    return(seq.mut)
}

#' Generate random synonymous mutations
#'
#' Generating random synonymous mutations (in user-defined region), with
#' optionally keeping/not keeping the original codon usage bias.
#'
#' @param object A regioned_dna object.
#' @param n Optional n parameter specifying what proportion of the codons to be
#'   mutated. Default value: \code{1}.
#' @param keep Logical parameter controling whether keeping the codon usage bias
# '   of the original sequence. Default value: \code{FALSE}.
#' @param numcode The ncbi genetic code number for translation. Default value: \code{1}. Details please refer to \code{?seqinr::translate} ("https://rdrr.io/cran/seqinr/man/translate.html").
#' @param ... ...
#'
#' @details This method randomly sample synonymous codons for \code{n} propotion
#'   of every mutable codons in the sequences. This process will be likely to
#'   alter the codon usage bias of the original sequences. However the
#'   \code{keep = TRUE} argument help to preserve the codon usage bias. It is
#'   done via the \code{synsequence} function in \code{seqinr} package. The
#'   \code{synsequence} function essentially swaps the position of the
#'   synonymous codons without introducing new codons into the original
#'   sequences.
#' 
#' @return A regioned_dna object containing the mutants; Or a DNAStringSet
#'   object if the input is a DNAStringSet object.
#' @seealso \code{\link{input_seq}}, \code{\link{dinu_to}},
#'   \code{\link{codon_to}}, \code{\link{codon_mimic}}
#' @examples
#' filepath <- system.file("extdata", "example.fasta", package = "SynMut")
#' rgd.seq <- input_seq(filepath)
#' set.seed(2019)
#' get_cu(codon_random(rgd.seq, n = 0.5))
#' get_cu(codon_random(rgd.seq))
#' @name codon_random
#' @rdname codon_random-methods
#'
#' @exportMethod codon_random
#' @importFrom seqinr c2s s2c synsequence splitseq syncodons
#' @importFrom Biostrings DNAStringSet
#' @import methods
#' @include regioned_dna_Class.R input_seq.R
setGeneric(
    name = "codon_random",
    def = function(object, n = 1, keep = FALSE, numcode = 1,
                   ...) standardGeneric(f = "codon_random")
)

#' @rdname codon_random-methods
setMethod(
    f = "codon_random",
    signature = "regioned_dna",
    definition = function(object, n, keep, numcode) {
        if (!is.logical(keep)) {
            stop("'keep' should be either TRUE or FALSE")
        }
        check.n <- all(n > 0, n <= 1)
        if (is.na(n)) {
            n = 1
        } else if (!check.n) {
            stop("n must be at range (0, 1]")
        } else {
            n = n
        }

        check.region <- all(is.na(object@region))
        seq <- convert_to_seq(object@dnaseq)
        seq.region <- extract_region(object, check.region)

        seq.mut <- mutation_random_main(seq.region, n, keep, numcode)

        seq.mut <- region_back(seq.mut, check.region, seq, object)

        return(new(
            "regioned_dna",
            dnaseq = seq.mut,
            region = object@region
        ))
    }
)

#' @rdname codon_random-methods
setMethod(
    f = "codon_random",
    signature = "DNAStringSet",
    definition = function(object, n, keep, numcode) {
        object <- c(object, DNAStringSet("ATG"))
        seq <- lapply(as.character(object), function(x) {
            splitseq(s2c(x))
        })

        seq.mut <- mutation_random_main(seq, n, keep, numcode)

        seq.mut <- seq.mut[seq_len(length(seq.mut) - 1)]
        seq.mut <- DNAStringSet(unlist(lapply(seq.mut, c2s)))

        return(seq.mut)
    }
)


# helper function ---------------------------------------------------------

mutation_random_main <- function(seq.region, n, keep, numcode){
    if (n != 1) {
        id <- lapply(seq.region, function(x) {
            id <- sample(seq_len(length(x)), round(length(x) * n))
        })
        seq.mut <- mapply(function(x, y) {
            x[y]
        }, seq.region, id, SIMPLIFY = FALSE)
    } else {
        seq.mut <- seq.region
    }

    if (keep == FALSE) {
        seq.mut <- lapply(seq.mut, function(x) {
            toupper(vapply(syncodons(x, numcode = numcode), function(x) {
                sample(x, 1)
            }, character(1)))
        })
    } else {
        seq.mut <- lapply(seq.mut, function(x) {
            splitseq(synsequence(s2c(c2s(x)), numcode = numcode))
        })
    }

    if (n != 1) {
        seq.mut <- mapply(function(x, y, z) {
            x[y] <- z
            return(x)
        }, seq.region, id, seq.mut, SIMPLIFY = FALSE)
    }

    return(seq.mut)
}

# Class definition --------------------------------------------------------

#' An S4 class to record DNA sequences and variable regions for mutations
#'
#' Recording codon DNA sequences and region.
#'
#' @slot dnaseq a DNAStingSet object recording the sequence(s)
#' @slot region a list specifying paticular regions in the sequences
#'   allowed to be mutated
#'
#' @importFrom methods setClass
#' @import Biostrings
#' @seealso \code{\link{input_seq}}, \code{\link{get_cu}},
#'   \code{\link{get_region}}
#' @author Haogao Gu
#' @name regioned_dna-class
#' @rdname regioned_dna-class
#' @exportClass regioned_dna

setClass(Class = "regioned_dna",
    slots = c(dnaseq = "DNAStringSet",
        region = "list"))

setValidity("regioned_dna",
    function(object) {
        object.region <- object@region
        object.seq <- object@dnaseq
        check.na <- all(is.na(object.region))
        dnaseq.n <- length(object.seq)
        region.n <- length(object.region)
        check.3 <-
            all(vapply(object.seq, length, numeric(1)) %% 3 == 0)
        if (!check.na) {
            check.length <- dnaseq.n == region.n
            check.num <-
                vapply(object.seq, length, numeric(1)) / 3 ==
                vapply(object.region, length, numeric(1))
        } else {
            check.num <- TRUE
            check.length <- TRUE
        }
        if (!check.3) {
            stop("the length of the dna sequences must be divisible by 3")
        }
        if (all(check.num, check.length)) {
            TRUE
        } else{
            "dnaseq and region must have the same length."
        }
    })

##viewer
setMethod(
    f = "show",
    signature = "regioned_dna",
    definition = function(object) {
        cat("An object of class ", class(object), "\n", sep = "")
        cat("Number of sequences: ", length(object@dnaseq) - 1, "\n", sep = "")
    }
)


# Accessor ----------------------------------------------------------------

#' Get the variable region
#'
#' Access the variable regions
#'
#' @param object regioned_dna
#' @param ... ...
#'
#' @return list
#' @seealso \code{\link{input_seq}}, \code{\link{get_cu}}
#' @examples
#' filepath <- system.file("extdata", "example.fasta", package = "SynMut")
#' rgd.seq <- input_seq(filepath)
#' get_region(rgd.seq)
#' @name get_region
#' @rdname get_region-methods
#' @exportMethod get_region
setGeneric(
    name = "get_region",
    def = function(object, ...) standardGeneric("get_region")
)

#' @rdname get_region-methods
setMethod(
    f = "get_region",
    signature = "regioned_dna",
    definition = function(object) {
        object@region[seq_len(length(object@region) - 1)]
    }
)

#' Get the DNAStringSet data
#'
#' Access the DNA sequence data in DNAStringSet.
#'
#' @param object A regioned_dna object.
#' @param ... ...
#'
#' @return DNAStringSet
#' @exportMethod get_dna
#' @name get_dna
#' @rdname get_dna-methods
#'
#' @examples
#' filepath <- system.file("extdata", "example.fasta", package = "SynMut")
#' rgd.seq <- input_seq(filepath)
#' get_dna(rgd.seq)
setGeneric(
    name = "get_dna",
    def = function(object, ...) standardGeneric("get_dna")
)

#' @rdname get_dna-methods
setMethod(
    f = "get_dna",
    signature = "regioned_dna",
    definition = function(object) {
        return(object@dnaseq[seq_len(length(object@dnaseq) - 1)])
    }
)


# simple calculation ------------------------------------------------------

#' Get codon usage matrix
#'
#' Access the codon usage matrix
#'
#' @param object regioned_dna / DNAStringSet
#' @param ... ...
#'
#' @return matrix
#' @seealso \code{\link{input_seq}}, \code{\link{get_region}},
#'   \code{\link{get_nu}}, \code{\link{get_du}}, \code{\link{get_freq}},
#'   \code{\link{get_rscu}}
#' @examples
#' filepath <- system.file("extdata", "example.fasta", package = "SynMut")
#' rgd.seq <- input_seq(filepath)
#' get_cu(rgd.seq)
#' @exportMethod get_cu
#' @name get_cu
#' @rdname get_cu-methods
setGeneric(
    name = "get_cu",
    def = function(object, ...) standardGeneric("get_cu")
)

#' @rdname get_cu-methods
setMethod(
    f = "get_cu",
    signature = "regioned_dna",
    definition = function(object) {
        dnaseq <- object@dnaseq[seq_len(length(object@dnaseq) - 1)]
        oligonucleotideFrequency(dnaseq, width = 3, step = 3)
    }
)

#' @rdname get_cu-methods
setMethod(
    f = "get_cu",
    signature = "DNAStringSet",
    definition = function(object) {
        oligonucleotideFrequency(object, width = 3, step = 3)
    }
)

#' Get dinucleotide usage matrix
#'
#' Access the dinucleotide usage matrix
#'
#' @param object regioned_dna / DNAStringSet
#' @param ... ...
#'
#' @return matrix
#' @seealso \code{\link{input_seq}}, \code{\link{get_region}},
#'   \code{\link{get_nu}}, \code{\link{get_cu}}, \code{\link{get_freq}},
#'   \code{\link{get_rscu}}
#' @examples
#' filepath <- system.file("extdata", "example.fasta", package = "SynMut")
#' rgd.seq <- input_seq(filepath)
#' get_du(rgd.seq)
#' @exportMethod get_du
#' @name get_du
#' @rdname get_du-methods
setGeneric(
    name = "get_du",
    def = function(object, ...) standardGeneric("get_du")
)

#' @rdname get_du-methods
setMethod(
    f = "get_du",
    signature = "regioned_dna",
    definition = function(object) {
        dnaseq <- object@dnaseq[seq_len(length(object@dnaseq) - 1)]
        oligonucleotideFrequency(dnaseq, width = 2, step = 1)
    }
)

#' @rdname get_du-methods
setMethod(
    f = "get_du",
    signature = "DNAStringSet",
    definition = function(object) {
        oligonucleotideFrequency(object, width = 2, step = 1)
    }
)

#' Get nucleotide usage matrix
#'
#' Access the nucleotide usage matrix
#'
#' @param object regioned_dna / DNAStringSet
#' @param ... ...
#'
#' @return matrix
#' @seealso \code{\link{input_seq}}, \code{\link{get_region}},
#'   \code{\link{get_cu}}, \code{\link{get_du}}, \code{\link{get_rscu}}
#' @examples
#' filepath <- system.file("extdata", "example.fasta", package = "SynMut")
#' rgd.seq <- input_seq(filepath)
#' get_nu(rgd.seq)
#' @exportMethod get_nu
#' @name get_nu
#' @rdname get_nu-methods
setGeneric(
    name = "get_nu",
    def = function(object, ...) standardGeneric("get_nu")
)

#' @rdname get_nu-methods
setMethod(
    f = "get_nu",
    signature = "regioned_dna",
    definition = function(object) {
        dnaseq <- object@dnaseq[seq_len(length(object@dnaseq) - 1)]
        oligonucleotideFrequency(dnaseq, width = 1, step = 1)
    }
)

#' @rdname get_nu-methods
setMethod(
    f = "get_nu",
    signature = "DNAStringSet",
    definition = function(object) {
        oligonucleotideFrequency(object, width = 1, step = 1)
    }
)

#' Get codon usage frequency of synonymous codons
#'
#' Access the synonymous codon usage frequency
#'
#' @param object regioned_dna / DNAStringSet / codon usage matrix (vector)
#' @param numcode The ncbi genetic code number for translation. Default value: \code{1}. Details please refer to \code{?seqinr::translate} ("https://rdrr.io/cran/seqinr/man/translate.html").
#' @param ... ...
#'
#' @return matrix
#' @seealso \code{\link{input_seq}}, \code{\link{get_region}},
#'   \code{\link{get_cu}}, \code{\link{get_du}}, \code{\link{get_rscu}}
#' @examples
#' filepath <- system.file("extdata", "example.fasta", package = "SynMut")
#' rgd.seq <- input_seq(filepath)
#' get_freq(rgd.seq)
#' @exportMethod get_freq
#' @name get_freq
#' @rdname get_freq-methods
setGeneric(
    name = "get_freq",
    def = function(object, numcode = 1, ...) standardGeneric("get_freq")
)

#' @rdname get_freq-methods
setMethod(
    f = "get_freq",
    signature = "regioned_dna",
    definition = function(object, numcode) {
        dnaseq <- object@dnaseq[seq_len(length(object@dnaseq) - 1)]
        tmp <- oligonucleotideFrequency(dnaseq,
            width = 3, step = 3)
        tmp <- apply(tmp, 1, function(x) {
            r <- freq(x, numcode)
            names(r) <- NULL
            r <- unlist(r)[names(x)]
            return(r)
        })
        return(t(tmp))
    }
)

#' @rdname get_freq-methods
setMethod(
    f = "get_freq",
    signature = "DNAStringSet",
    definition = function(object, numcode) {
        tmp <-
            oligonucleotideFrequency(object, width = 3, step = 3)
        tmp <- apply(tmp, 1, function(x) {
            r <- freq(x, numcode)
            names(r) <- NULL
            r <- unlist(r)[names(x)]
            return(r)
        })
        return(t(tmp))
    }
)

#' @rdname get_freq-methods
setMethod(
    f = "get_freq",
    signature = "matrix",
    definition = function(object, numcode) {
        tmp <- apply(object, 1, function(x) {
            r <- freq(x, numcode)
            names(r) <- NULL
            r <- unlist(r)[names(x)]
            return(r)
        })
        return(t(tmp))
    }
)

#' @rdname get_freq-methods
setMethod(
    f = "get_freq",
    signature = "vector",
    definition = function(object, numcode) {
        r <- freq(object, numcode)
        names(r) <- NULL
        r <- unlist(r)[names(object)]
        return(r)
    }
)

#' Get Relative Synonymous Codon Usage (rscu) of synonymous codons
#'
#' Access the Relative Synonymous Codon Usage rscu
#'
#' @param object regioned_dna / DNAStringSet / codon usage matrix (vector)
#' @param numcode The ncbi genetic code number for translation. Default value: \code{1}. Details please refer to \code{?seqinr::translate} ("https://rdrr.io/cran/seqinr/man/translate.html").
#' @param ... ...
#'
#' @return matrix
#' @seealso \code{\link{input_seq}}, \code{\link{get_region}},
#'   \code{\link{get_cu}}, \code{\link{get_du}}, \code{\link{get_freq}}
#' @examples
#' filepath <- system.file("extdata", "example.fasta", package = "SynMut")
#' rgd.seq <- input_seq(filepath)
#' get_rscu(rgd.seq)
#' @exportMethod get_rscu
#' @name get_rscu
#' @rdname get_rscu-methods
setGeneric(
    name = "get_rscu",
    def = function(object, numcode=1, ...) standardGeneric("get_rscu")
)

#' @rdname get_rscu-methods
setMethod(
    f = "get_rscu",
    signature = "regioned_dna",
    definition = function(object, numcode) {
        dnaseq <- object@dnaseq[seq_len(length(object@dnaseq) - 1)]
        tmp <- oligonucleotideFrequency(dnaseq,
            width = 3, step = 3)
        tmp <- apply(tmp, 1, function(x) {
            r <- freq(x, numcode)
            r <- lapply(r, function(x) {
                return(x / ((1 / length(x)) * sum(x)))
            })
            names(r) <- NULL
            r <- unlist(r)[names(x)]
            return(r)
        })
        return(t(tmp))
    }
)

#' @rdname get_rscu-methods
setMethod(
    f = "get_rscu",
    signature = "DNAStringSet",
    definition = function(object, numcode) {
        tmp <-
            oligonucleotideFrequency(object, width = 3, step = 3)
        tmp <- apply(tmp, 1, function(x) {
            r <- freq(x, numcode)
            r <- lapply(r, function(x) {
                return(x / ((1 / length(x)) * sum(x)))
            })
            names(r) <- NULL
            r <- unlist(r)[names(x)]
            return(r)
        })
        return(t(tmp))
    }
)

#' Maximize or minimize the usage of certain dinucleotide.
#'
#' Input string of a dinucleotide to either the "max.dinu = " or "min.codon = "
#' parameter to maximize or minimize the usage of certain codon in the sequence.
#' Using a greedy algorithm with priority given to dinucleotide12 or
#' dinucleotide23.
#'
#' @param object A regioned_dna object.
#' @param max.dinu A string of a dinucleotide.
#' @param min.dinu A string of a dinucleotide.
#' @param keep A logical varibale stating if the codon usage of the original
#'   sequences should be keep. Default: False.
#' @param numcode The ncbi genetic code number for translation. Default value: \code{1}. Details please refer to \code{?seqinr::translate} ("https://rdrr.io/cran/seqinr/man/translate.html").
#' @param ... ...
#' @details The detail strategy for this function please refer to:
#' https://koohoko.github.io/SynMut/algorithm.html
#' @return regioned_dna
#' @seealso \code{\link{input_seq}}, \code{\link{codon_to}},
#'   \code{\link{codon_random}}, \code{\link{codon_mimic}}
#' @examples
#' filepath <- system.file("extdata", "example.fasta", package = "SynMut")
#' rgd.seq <- input_seq(filepath)
#' get_du(dinu_to(rgd.seq, max.dinu = "cg")) - get_du(rgd.seq)
#' get_du(dinu_to(rgd.seq, min.dinu = "AA")) - get_du(rgd.seq)
#' get_du(dinu_to(rgd.seq, max.dinu = "cg", keep = TRUE)) - get_du(rgd.seq)
#' get_cu(dinu_to(rgd.seq, max.dinu = "CG", keep = TRUE)) - get_cu(rgd.seq)
#' @include regioned_dna_Class.R
#' @exportMethod dinu_to
#' @importFrom stringr str_detect
#' @import methods
#' @import Biostrings
#' @name dinu_to
#' @rdname dinu_to-methods
setGeneric(
    name = "dinu_to",
    def = function(object, max.dinu = NA, min.dinu = NA, keep = FALSE,
    numcode = 1, ...) standardGeneric("dinu_to")
)

#' @rdname dinu_to-methods
setMethod(
    f = "dinu_to",
    signature = "regioned_dna",
    definition = function(object, max.dinu, min.dinu, keep, numcode) {
        max.dinu <- toupper(max.dinu)
        min.dinu <- toupper(min.dinu)
        dinu.input <- c(max.dinu, min.dinu)
        dinu.input <- dinu.input[!is.na(dinu.input)]
        if (length(dinu.input) == 0) {
            stop("please specify at least one parameter of
            'max.dinu' or 'min.dinu'")
        }
        if (all(!is.na(c(max.dinu, min.dinu)))) {
            stop("Only one parameter is supported between
            'max.dinu' and 'min.dinu'")
        }
        if (length(dinu.input) > 2) {
            stop("Only one dinucleotide is allowed for
            input in 'max.dinu' or 'min.dinu'")
        }
        check.valid.dinu <- toupper(dinu.input) %in%
            toupper(mkAllStrings(c("a", "t", "c", "g"), 2))
        if (!check.valid.dinu) {
            stop("Please input valid DNA dinucleotide")
        }

        # extract region ------------------------------------------------------

        region <- object@region
        check.region <- all(is.na(region))
        seq <- convert_to_seq(object@dnaseq)
        seq.region <- extract_region(object, check.region)

        # mutation ------------------------------------------------------------

        codon.list <-
            lapply(seqinr::ucoweight('', numcode=numcode), function(x) {
                toupper(names(x))
            })
        codon.list.alt <-
            codon.list[vapply(codon.list, function(x) {
                length(x) > 1
            }, logical(1))]

        if (keep == FALSE) {
            seq.mut <-
                dinu_to.not.keep(seq.region, codon.list.alt, max.dinu, min.dinu)
        } else {
            seq.mut <- seq.region
        }

        # merge region --------------------------------------------------------

        if (!check.region) {
            seq.mut <- mapply(function(x, y, z) {
                x[y] <- z
                return(x)
            }, seq, region, seq.mut, SIMPLIFY = FALSE)
        }

        # synonmous codon interchange -----------------------------------------

        seq.mut <-
            dinu_to.keep(check.region,
                seq.mut,
                max.dinu,
                min.dinu,
                codon.list.alt,
                region,
                numcode)

        # export --------------------------------------------------------------

        seq.mut <- DNAStringSet(unlist(lapply(seq.mut, c2s)))
        return(new(
            "regioned_dna",
            dnaseq = seq.mut,
            region = object@region
        ))

    }
)

###########################################################################
# internal helper function ------------------------------------------------
###########################################################################

#1: not keep codon usage, mutate at all 12, 23 and 31 regions

dinu_to.not.keep <-
    function(seq.region,
        codon.list.alt,
        max.dinu,
        min.dinu) {
        ## get optimal codon
        codon.list.optm <- get_optimal_codon(codon.list.alt, max.dinu, min.dinu)

        ## mutate codons to optimals
        seq.mut <- seq.region
        for (i in seq_along(codon.list.optm)) {
            codons.alt <- codon.list.alt[[i]]
            codons.alt <-
                codons.alt[codons.alt != codon.list.optm[[i]]]
            seq.mut <- lapply(seq.mut, function(x) {
                x[x %in% codons.alt] <- codon.list.optm[[i]]
                return(x)
            })
        }

        return(seq.mut)
    }

get_optimal_codon <- function(codon.list.alt, max.dinu, min.dinu){
    check.max <- !is.na(max.dinu)
    target.codon <- c(max.dinu, min.dinu)[!is.na(c(max.dinu, min.dinu))]
    codon.list.optm <- lapply(codon.list.alt, function(x) {
        filter1 <- if(check.max){
            x[str_detect(x, pattern = target.codon)]
        } else {
            x[!str_detect(x, pattern = target.codon)]
        }

        if (length(filter1) == 1) {
            return(filter1)
        } else {
            pattern2.1 <- paste0("^", substr(target.codon, 2, 2))
            pattern2.2 <-
                paste0(substr(target.codon, 1, 1), "$")
            if (length(filter1) > 1){
                x <- filter1
            }
            filter2.1 <- if(check.max){
                x[str_detect(x, pattern = pattern2.1)]
            } else {
                x[!str_detect(x, pattern = pattern2.1)]
            }

            filter2.2 <- if(check.max){
                x[str_detect(x, pattern = pattern2.2)]
            } else {
                x[!str_detect(x, pattern = pattern2.2)]
            }

            filter2 <- c(filter2.1, filter2.2)
            if (length(filter2) < 1) {
                return(sample(x, 1))
            } else{
                table.sorted <- sort(table(filter2), decreasing = TRUE)
                names.ordered <- names(table.sorted)
                choice.good <-
                    names.ordered[table.sorted == table.sorted[1]]
                return(sample(choice.good, 1))
            }
        }
    })
    return(codon.list.optm)
}

#2: keep codon usage, mutate at only 31 regions
dinu_to.keep <-
    function(check.region, seq.mut, max.dinu, min.dinu, codon.list.alt,
        region, numcode) {
        check.max <- !is.na(max.dinu)
        if (check.max) {
            dinu.target <- max.dinu
        } else {
            dinu.target <- min.dinu
        }
        seq.aa <- lapply(seq.mut, function(x) {
            seqinr::translate(s2c(c2s(x)), numcode=numcode)
        })

        check.head.g <- lapply(seq.mut, function(x){
            substr(x, 1, 1) == substr(dinu.target, 2, 2)
        })

        if(!check.region){ # have region
            pos.to.mut <- mapply(function(x, y){
                intersect((which(x) - 1), which(y))
            }, check.head.g, region)
        } else { # no region
            pos.to.mut <- lapply(check.head.g, function(x){
                setdiff((which(x) - 1), 0)
            })
        }

        seq.mut <- mapply(function(seq.mut.i, pos.to.mut.i, seq.aa.i, region.i){
            if(length(pos.to.mut.i) < 1){
                return(seq.mut.i)
            } else {
                aa.to.mut <- seq.aa.i[pos.to.mut.i]
                aa.to.mut.unique <- unique(aa.to.mut)

                for(i in seq_along(aa.to.mut.unique)){
                    aa.tmp <- aa.to.mut.unique[i]
                    pos.to.mut.tmp <- pos.to.mut.i[aa.to.mut == aa.tmp]

                    if(!check.region){ # have region
                        pos.for.select <- intersect(which(seq.aa.i == aa.tmp),
                            which(region.i))
                    } else { # no region
                        pos.for.select <- which(seq.aa.i == aa.tmp)
                    }
                    pos.for.select <- setdiff(pos.for.select, pos.to.mut.tmp)

                    if(check.max){ # max dinu
                        pos.to.mut.tmp <-
                            pos.to.mut.tmp[substr(seq.mut.i[pos.to.mut.tmp],
                                3, 3) != substr(dinu.target, 1, 1)]
                        pos.for.select <-
                            pos.for.select[substr(seq.mut.i[pos.for.select],
                                3, 3) == substr(dinu.target, 1, 1)]
                        if(length(pos.to.mut.tmp) > 0){
                            if(length(pos.to.mut.tmp)>=length(pos.for.select)){
                                pos.to.mut.tmp <-as.numeric(sample(as.character(
                                    pos.to.mut.tmp), length(pos.for.select)))
                            } else {
                                pos.for.select <-as.numeric(sample(as.character(
                                    pos.for.select), length(pos.to.mut.tmp)))
                            }
                            codon.to.mut <- seq.mut.i[pos.to.mut.tmp]
                            codon.for.select <- seq.mut.i[pos.for.select]
                            seq.mut.i[pos.to.mut.tmp] <- codon.for.select
                            seq.mut.i[pos.for.select] <- codon.to.mut
                        }

                    } else { # min dinu
                        pos.to.mut.tmp <-
                            pos.to.mut.tmp[substr(seq.mut.i[pos.to.mut.tmp],
                                3, 3) == substr(dinu.target, 1, 1)]
                        pos.for.select <-
                            pos.for.select[substr(seq.mut.i[pos.for.select],
                                3, 3) != substr(dinu.target, 1, 1)]
                        if(length(pos.to.mut.tmp) > 0){
                            if(length(pos.to.mut.tmp)>=length(pos.for.select)){
                                pos.to.mut.tmp <-as.numeric(sample(as.character(
                                    pos.to.mut.tmp), length(pos.for.select)))
                            } else {
                                pos.for.select <-as.numeric(sample(as.character(
                                    pos.for.select), length(pos.to.mut.tmp)))
                            }
                            codon.to.mut <- seq.mut.i[pos.to.mut.tmp]
                            codon.for.select <- seq.mut.i[pos.for.select]
                            seq.mut.i[pos.to.mut.tmp] <- codon.for.select
                            seq.mut.i[pos.for.select] <- codon.to.mut
                        }
                    }
                }
                return(seq.mut.i)
            }
        }, seq.mut, pos.to.mut, seq.aa, region)

        return(seq.mut)
    }

context("Mutations")
library("SynMut")
filepath <- system.file("extdata", "example.fasta", package = "SynMut")
filepath.csv <- system.file("extdata", "target_regions.csv", package = "SynMut")
region <- read.csv(filepath.csv)
rgd.seq <- input_seq(filepath, region)
rgd.seq.no.region <- input_seq(filepath)

filepath <-
    system.file("extdata", "example2.fasta", package = "SynMut")
rgd.seq.single <- input_seq(filepath)

test_that("codon_random", {
    expect_silent(seq_random(n = 1, m = 99))
    expect_silent(seq_random(n = 10, m = 30))
    expect_silent(seq_random(n = 10, m = 1:10))
    expect_silent(seq_random(
        n = 10,
        m = 100,
        no.stop.codon = TRUE
    ))
})

test_that("codon_random", {
    tmp <- codon_random(rgd.seq, n = 0.5)
    expect_true(class(tmp)[1] == "regioned_dna")
    expect_silent(codon_random(rgd.seq.single, n = 0.5))
    expect_silent(codon_random(rgd.seq.no.region, n = 0.5))

    # test numcode
    expect_silent(codon_random(rgd.seq.single, n = 0.5, numcode=2))
    ori <- get_dna(rgd.seq.single)
    mut_1 <- get_dna(codon_random(rgd.seq.single, n = 1, keep = TRUE, numcode=1)) 
    mut_2 <- get_dna(codon_random(rgd.seq.single, n = 1, keep = TRUE)) 
    mut_3 <- get_dna(codon_random(rgd.seq.single, n = 1, keep = TRUE, numcode=5)) 
    expect_true(Biostrings::translate(mut_1) == Biostrings::translate(mut_2))
    expect_false(Biostrings::translate(ori) == Biostrings::translate(mut_3))
    expect_true(Biostrings::translate(ori, genetic.code=getGeneticCode("5")) == Biostrings::translate(mut_3, genetic.code=getGeneticCode("5")))
    expect_true(all(get_cu(mut_1) == get_cu(mut_3)))
})

test_that("codon_to", {
    expect_error(codon_to(rgd.seq, max.codon = "aac", min.codon = "aac"))
    expect_error(codon_to(rgd.seq))
    expect_error(codon_to(rgd.seq, min.codon = "aaaa"))
    tmp <-
        get_cu(codon_to(rgd.seq, max.codon = "AAC")) - get_cu(rgd.seq)
    expect_true(class(tmp)[1] == "matrix")
    expect_silent(codon_to(rgd.seq.single, min.codon = "aaa"))
    expect_silent(codon_to(rgd.seq.no.region, min.codon = "aaa"))
})

test_that("dinu_to", {
    tmp <- dinu_to(rgd.seq, max.dinu = "cg")
    expect_true(class(tmp)[1] == "regioned_dna")
    tmp <- get_du(dinu_to(rgd.seq, min.dinu = "aa")) - get_du(rgd.seq)
    expect_true(class(tmp)[1] == "matrix")
    expect_silent(dinu_to(rgd.seq.single, max.dinu = "cg"))
    expect_silent(dinu_to(rgd.seq.no.region, max.dinu = "cg"))

    expect_silent(get_du(dinu_to(
        rgd.seq, max.dinu = "cg", keep = TRUE
    )))
    expect_silent(get_du(dinu_to(
        rgd.seq, min.dinu = "tg", keep = TRUE
    )))
    expect_silent(get_cu(dinu_to(
        rgd.seq.single, max.dinu = "cg", keep = TRUE
    )))
    expect_silent(get_du(dinu_to(
        rgd.seq.single, min.dinu = "tg", keep = TRUE
    )))
    expect_silent(get_cu(dinu_to(
        rgd.seq.no.region, max.dinu = "cg", keep = TRUE
    )))
    expect_silent(get_du(dinu_to(
        rgd.seq.no.region, min.dinu = "tg", keep = TRUE
    )))

    # test numcode
    ori <- get_dna(rgd.seq.single)
    mut_1 <- get_dna(dinu_to(rgd.seq.single, max.dinu = "cg", keep = TRUE, numcode=1)) 
    mut_2 <- get_dna(dinu_to(rgd.seq.single, max.dinu = "cg", keep = TRUE)) 
    mut_3 <- get_dna(dinu_to(rgd.seq.single, max.dinu = "cg", keep = TRUE, numcode=5)) 

    expect_true(Biostrings::translate(mut_1) == Biostrings::translate(mut_2))
    expect_true(Biostrings::translate(ori) == Biostrings::translate(mut_2))
    expect_true(Biostrings::translate(ori, genetic.code=getGeneticCode("5")) == Biostrings::translate(mut_3, genetic.code=getGeneticCode("5")))
    expect_true(all(get_cu(mut_1) == get_cu(mut_3)))
    expect_true(all(get_cu(ori) == get_cu(mut_3)))

})

test_that("codon_mimic", {
    target <- get_cu(rgd.seq)[2,]
    new <- codon_mimic(rgd.seq, alt = target)
    tmp <- get_freq(new) - get_freq(rgd.seq)
    expect_true(class(tmp)[1] == "matrix")

    target <- Biostrings::DNAStringSet("TTGAAAA-CTC-N--AAG")
    new <- codon_mimic(rgd.seq, alt = target)
    tmp <- get_cu(new) - get_cu(rgd.seq)
    expect_true(class(tmp)[1] == "matrix")

    expect_silent(codon_mimic(rgd.seq.single, alt = target))
    expect_silent(codon_mimic(rgd.seq.no.region, alt = target))

     # test numcode
    ori <- get_dna(rgd.seq.single)
    target <- get_cu(rgd.seq)[2,]
    mut_1 <- get_dna(codon_mimic(rgd.seq.single, alt = target))
    mut_2 <- get_dna(codon_mimic(rgd.seq.single, alt = target, numcode=1))
    mut_3 <- get_dna(codon_mimic(rgd.seq.single, alt = target, numcode=5))

    idx <- which(strsplit(consensusString(c(Biostrings::translate(ori), Biostrings::translate(mut_1))), "")[[1]]=="?")

    expect_true(Biostrings::translate(ori) == Biostrings::translate(mut_1))
    expect_true(Biostrings::translate(mut_1) == Biostrings::translate(mut_2))

    # expect_false(Biostrings::translate(ori, genetic.code=getGeneticCode("1")) == Biostrings::translate(mut_3, genetic.code=getGeneticCode("1")))
    expect_true(Biostrings::translate(ori, genetic.code=getGeneticCode("5")) == Biostrings::translate(mut_3, genetic.code=getGeneticCode("5")))

})

test_that("dinu_dist", {
    expect_silent(codon_dist(codon_random(rgd.seq), rgd.seq))
    expect_silent(dinu_dist(codon_random(rgd.seq), rgd.seq))
})

context("regioned_dna-Class")
library("SynMut")
filepath <-
    system.file("extdata", "example.fasta", package = "SynMut")
filepath.csv <-
    system.file("extdata", "target_regions.csv", package = "SynMut")
region <- read.csv(filepath.csv)
rgd.seq <- input_seq(filepath, region)

test_that("regioned_dna", {
    expect_true(class(rgd.seq)[1] == "regioned_dna")
    expect_error(input_seq(filepath, region = 1))
})

test_that("get_cu", {
    expect_true(is.matrix(get_cu(rgd.seq)))
})

test_that("get_du", {
    expect_true(is.matrix(get_du(rgd.seq)))
})

test_that("get_region", {
    expect_true(is.list(get_region(rgd.seq)))
})

test_that("get_dna", {
    expect_true(class(get_dna(rgd.seq))[1] == "DNAStringSet")
})

test_that("get_freq", {
    expect_true(is.matrix(get_freq(rgd.seq)))
})

test_that("get_rscu", {
    expect_true(is.matrix(get_rscu(rgd.seq)))
})

---
title: "SynMut: Tools for Designing Synonymously Mutated Sequences"
author: 
- "Haogao Gu, Leo L.M. Poon"
- "School of Public Health, The University of Hong Kong"
date: "`r Sys.Date()`"
output: 
  prettydoc::html_pretty:
    toc: true
    theme: tactile
    highlight: github
vignette: >
  %\VignetteIndexEntry{SynMut: Designing Synonymous Mutants for DNA Sequences}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

## Introduction
Synonymous mutations refer to the mutations in DNA/RNA sequences that cause
__no__ modification in the translated amino acid sequence. Most of the
synonymous mutations are also silent mutations as they do not have observable
effects on the organism's phenotype. Designing mutant sequences with synonymous
mutations is often applied in many biological studies as a method to control
some unwanted changes in the translated amino acid sequences.

The codon usage bias and dinucleotide usage bias are two genomic signatures in 
DNA/RNA sequences, even for synonymous sequences. Characterizing the functions
of synonymous sequences with different codon usage bias or dinucleotide usage
bias help to study their impacts on various biological functions. In fact, this 
method has been applied in many researches in virology.

`SynMut` provides tools for generating multiple synonymous DNA sequences of
different genomic features (in particular codon / dinucleotide usage pattern).
Users can also specify mutable regions in the sequences (this is particular
useful as there are some conserved regions in the genome which we do not want to
modify). This tool was originally designed for generating recombinant virus
sequences in influenza A virus to study the effects of different dinucleotide
usage and codon usage, yet these functions provided in this package can be
generic to a variety of other biological researches.

Below is a flowchart illustrating how the components work togaether in this
package.
```{r, echo=FALSE, message = FALSE}
url <- paste0("https://raw.githubusercontent.com/Koohoko/Koohoko.github.io/",
  "master/SynMut/images/component.png")
```
<center><img src="`r url`"></center>

## Getting started
### Installation
```{r, eval=FALSE}
if (!requireNamespace("BiocManager"))
    install.packages("BiocManager")
if (!requireNamespace("SynMut"))
    BiocManager::install("SynMut")
```

### Input data

We use the below data in the package for example. 

* `example.fasta`: The fasta file contains the segment 7 and segment 8 DNA
sequences of *Influenza A/Brisbane/59/2007 (H1N1) (BR59)*.
* `target_regions.csv`: The region file in csv format reads as a `data.frame`
specifying the user-defined mutable positions (in amino acid position)
correspond to the DNA sequences.

```{r, message=FALSE}
library("SynMut")
filepath.fasta <- system.file("extdata", "example.fasta", package = "SynMut")
filepath.csv <- system.file("extdata", "target_regions.csv", package = "SynMut")
region <- read.csv(filepath.csv)
```

The `input_seq` function takes either a system fasta file or a
DNAStringSet object as input, to construct a `regioned_dna` object that is used
in the `SynMut` package.

*Important Notes*: if the `region` parameter is specified in the resulted 
regioned_dna object, it will be automatically applied to all the downstream
functions for mutations. Mutations will only performed in the specified mutable
regions.

```{r}
rgd.seq <- input_seq(filepath.fasta, region)
rgd.seq
```

### Access the data
Various `get_` functions were used to get some useful information:

* `get_dna`: Access the DNA sequences. This will return a DNAStringSet object
(from `Biostrings` package).

```{r}
get_dna(rgd.seq)
```

* `get_region`: Access the user-defined mutable region. if there is no specified
regions, this function will return a `list` of length 0.

```{r}
str(get_region(rgd.seq))
get_region(input_seq(filepath.fasta))
```

* `get_cu`: Get the codon usage
* `get_du`: Get dinucleotide usage
* `get_nu`: Get nucleotide usage

```{r}
get_cu(rgd.seq)
get_du(rgd.seq)
get_nu(rgd.seq)
```

* We also provide functions to: 
    - get the codon usage frequency of synonymous codons: `get_freq`
    - get Relative Synonymous Codon Usage (rscu) of 
    synonymous codons: `get_rscu`

## Generating mutations
### Random synonymous mutants

Generating random synonymous mutations (in specific region if provided in the
`input_seq`), with optional keeping or not keeping the original codon usage
bias.

```{r}
# Random synonymous mutations
mut.seq <- codon_random(rgd.seq)
# Compare the codon usage
get_cu(mut.seq) - get_cu(rgd.seq)

# Keeping the original codon usage pattern
mut.seq <- codon_random(rgd.seq, keep = TRUE)
# Compare the codon usage
get_cu(mut.seq) - get_cu(rgd.seq)
```

We can also specify the `n` parameter to control the proportion of the codons to
be mutated.

```{r}
# Fifty percent of the codons were allowed for mutation
mut.seq <- codon_random(rgd.seq, n = 0.5)
# Compare the codon usage
get_cu(mut.seq) - get_cu(rgd.seq)
```

### Synonymous mutants with maximal/minimal usage of specific codon

When studying the role of a particular codon, it would be useful to have
the mutants with maximal/minimal usage of that codon. The `codon_to` function
will do this job for you. Pass a string of codon to either the `max.codon` or
`min.codon` argument to maximize or minimize the usage of certain codon in the 
sequence.

```{r}
# Generate AAC-maximized mutations
mut.seq <- codon_to(rgd.seq, max.codon = "AAC")
# Compare the codon usage
get_cu(mut.seq) - get_cu(rgd.seq)

# Generate AAC-minimized mutations
mut.seq <- codon_to(rgd.seq, min.codon = "AAC")
# Compare the codon usage
get_cu(mut.seq) - get_cu(rgd.seq)
```

### Synonymous mutants with maximal/minimal usage of specific dinucleotide

Use `dinu_to` to generate mutations with maximal/minimal usage of specific 
dinucleotide. This was done by a two-step heuristic greedy algorithm, details 
can be found at this [link](https://koohoko.github.io/SynMut/algorithm.html).

An alternative `keep = TRUE` argument allow retaining the original codon usage
bias. This can be useful when in combination with `codon_mimic` in the [next
section](#synonymous-mutants-mimicking-a-specific-codon-usage-pattern) to design
mutant sequences with similar codon usage bias but distinct specific
dinucleotide usage.

```{r}
# Maximaize the usage of "CG" dinucleotide in the pre-defined region
mut.seq <- dinu_to(rgd.seq, max.dinu = "cg")
# Check the dinucelotide usage difference between the mutant and the original
get_du(mut.seq) - get_du(rgd.seq)

# Minimize the usage of "CA", and compare the dinucleotide usage.
mut.seq <- dinu_to(rgd.seq, min.dinu = "CA")
get_du(mut.seq) - get_du(rgd.seq)

# Maximize the usage of "CG" while keeping the original codon usage
mut.seq <- dinu_to(rgd.seq, max.dinu = "cg", keep = TRUE)
# Compare the dinucleotide usage
get_du(mut.seq) - get_du(rgd.seq)
# Compare the codon usage
get_cu(mut.seq) - get_cu(rgd.seq)

```

### Synonymous mutants mimicking a specific codon usage pattern 

The function `codon_mimic` mutates the sequences to mimic a target codon usage 
patterns. Detail algorithm was provided at this
[link](https://koohoko.github.io/SynMut/algorithm.html).

The `alt` argument specifies the target codon usage in either a codon usage 
vector (result from `get_cu`) or a DNAStringSet of length 1 representing the 
desired codon usage.

```{R}
# Use a codon usage vector as a target
target <- get_cu(rgd.seq)[2,]
mut.seq <- codon_mimic(rgd.seq, alt = target)
# Compare the codon usage
get_cu(mut.seq) - get_cu(rgd.seq)

# Use a sequence as a target
target <- Biostrings::DNAStringSet("TTGAAAA-CTC-N--AAG")
mut.seq <- codon_mimic(rgd.seq, alt = target)
# Compare the codon usage
get_cu(mut.seq) - get_cu(rgd.seq)
# Compare the synonymous codon usage frequency
get_freq(mut.seq) - get_freq(rgd.seq)
# Compare the Relative Synonymous Codon Usage (RSCU)
get_rscu(mut.seq) - get_rscu(rgd.seq)

```

## Output the results

Output the DNA mutant sequences
```{r, eval = FALSE}
Biostrings::writeXStringSet(get_dna(rgd.seq), "rgd.fasta")
```

## Session information
```{R}
sessionInfo()
```
***

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/regioned_dna_Class.R
\name{get_rscu}
\alias{get_rscu}
\alias{get_rscu,regioned_dna-method}
\alias{get_rscu,DNAStringSet-method}
\title{Get Relative Synonymous Codon Usage (rscu) of synonymous codons}
\usage{
get_rscu(object, numcode = 1, ...)

\S4method{get_rscu}{regioned_dna}(object, numcode)

\S4method{get_rscu}{DNAStringSet}(object, numcode)
}
\arguments{
\item{object}{regioned_dna / DNAStringSet / codon usage matrix (vector)}

\item{numcode}{The ncbi genetic code number for translation. Default value: \code{1}. Details please refer to \code{?seqinr::translate} ("https://rdrr.io/cran/seqinr/man/translate.html").}

\item{...}{...}
}
\value{
matrix
}
\description{
Access the Relative Synonymous Codon Usage rscu
}
\examples{
filepath <- system.file("extdata", "example.fasta", package = "SynMut")
rgd.seq <- input_seq(filepath)
get_rscu(rgd.seq)
}
\seealso{
\code{\link{input_seq}}, \code{\link{get_region}},
  \code{\link{get_cu}}, \code{\link{get_du}}, \code{\link{get_freq}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/input_seq.R
\name{input_seq}
\alias{input_seq}
\alias{input_seq,character-method}
\alias{input_seq,DNAStringSet-method}
\alias{input_seq,DNAString-method}
\title{Import region / constructing regioned_dna object}
\usage{
input_seq(object, region = NA, ...)

\S4method{input_seq}{character}(object, region)

\S4method{input_seq}{DNAStringSet}(object, region)

\S4method{input_seq}{DNAString}(object, region)
}
\arguments{
\item{object}{Filepath or DNAstringSet. The input sequences is suggested to
be in open reading frame(ORF).}

\item{region}{\code{NA}. A data.frame specifying paticular regions (positions
in amino acid sequence) that is allowed to be mutated in the sequences.
Both \code{1 / 0} or \code{TRUE / FALSE} encoding is OK. Please refer to
Examples below for reference.}

\item{...}{...}
}
\value{
A regioned_dna-class object
}
\description{
Constructing \code{regioned_dna} from DNAStringSet. Optionally input a
\code{region} data.frame to define restricted amino-acid region for mutation.
}
\examples{
# Creating a input_seq class directly from system file
filepath <- system.file("extdata", "example.fasta", package = "SynMut")
rgd.seq <- input_seq(filepath)

# Optionally input with region dataframe
filepath.fasta <- system.file("extdata", "example.fasta", package = "SynMut")
fp.csv <- system.file("extdata", "target_regions.csv", package = "SynMut")
region <- read.csv(fp.csv)
rgd.seq <- input_seq(filepath.fasta, region)

# Creating from exsisting DNAStringSet object
seq <- Biostrings::DNAStringSet("ATCGATCGA")
rgd.seq <- input_seq(seq)

}
\seealso{
\code{\link{get_cu}}, \code{\link{get_du}},
  \code{\link{get_region}}, \code{\link{get_dna}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/codon_to.R
\name{codon_to}
\alias{codon_to}
\alias{codon_to,regioned_dna-method}
\title{Maximize or minimize the usage of certain codon.}
\usage{
codon_to(object, max.codon = NA, min.codon = NA, ...)

\S4method{codon_to}{regioned_dna}(object, max.codon, min.codon)
}
\arguments{
\item{object}{A regioned_dna object.}

\item{max.codon}{A string of a codon.}

\item{min.codon}{A string of a codon.}

\item{...}{...}
}
\value{
A regioned_dna object.
}
\description{
Input string of a codon to either the "max.codon = " or "min.codon = "
parameter to maximize or minimize the usage of certain codon in the sequence.
}
\details{
The ideas for this function is simple. We first extract the mutable
  regions for every sequences, then mutated the synonymous codons of the
  input to the desired. There will be only one ideal design for the
  maximization problem, however there may be numerous comparable designs
  having the same minimal usage of certain codon, as we randomly sample
  synonymous codon for substitution when solving the minimization problem.
}
\examples{
filepath <- system.file("extdata", "example.fasta", package = "SynMut")
rgd.seq <- input_seq(filepath)
get_cu(codon_to(rgd.seq, max.codon = "AAC")) - get_cu(rgd.seq)
get_cu(codon_to(rgd.seq, min.codon = "AAC")) - get_cu(rgd.seq)

}
\seealso{
\code{\link{input_seq}}, \code{\link{dinu_to}},
  \code{\link{codon_random}}, \code{\link{codon_mimic}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/regioned_dna_Class.R
\name{get_cu}
\alias{get_cu}
\alias{get_cu,regioned_dna-method}
\alias{get_cu,DNAStringSet-method}
\title{Get codon usage matrix}
\usage{
get_cu(object, ...)

\S4method{get_cu}{regioned_dna}(object)

\S4method{get_cu}{DNAStringSet}(object)
}
\arguments{
\item{object}{regioned_dna / DNAStringSet}

\item{...}{...}
}
\value{
matrix
}
\description{
Access the codon usage matrix
}
\examples{
filepath <- system.file("extdata", "example.fasta", package = "SynMut")
rgd.seq <- input_seq(filepath)
get_cu(rgd.seq)
}
\seealso{
\code{\link{input_seq}}, \code{\link{get_region}},
  \code{\link{get_nu}}, \code{\link{get_du}}, \code{\link{get_freq}},
  \code{\link{get_rscu}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/regioned_dna_Class.R
\name{get_dna}
\alias{get_dna}
\alias{get_dna,regioned_dna-method}
\title{Get the DNAStringSet data}
\usage{
get_dna(object, ...)

\S4method{get_dna}{regioned_dna}(object)
}
\arguments{
\item{object}{A regioned_dna object.}

\item{...}{...}
}
\value{
DNAStringSet
}
\description{
Access the DNA sequence data in DNAStringSet.
}
\examples{
filepath <- system.file("extdata", "example.fasta", package = "SynMut")
rgd.seq <- input_seq(filepath)
get_dna(rgd.seq)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/regioned_dna_Class.R
\docType{class}
\name{regioned_dna-class}
\alias{regioned_dna-class}
\title{An S4 class to record DNA sequences and variable regions for mutations}
\description{
Recording codon DNA sequences and region.
}
\section{Slots}{

\describe{
\item{\code{dnaseq}}{a DNAStingSet object recording the sequence(s)}

\item{\code{region}}{a list specifying paticular regions in the sequences
allowed to be mutated}
}}

\seealso{
\code{\link{input_seq}}, \code{\link{get_cu}},
  \code{\link{get_region}}
}
\author{
Haogao Gu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/codon_mimic.R
\name{codon_mimic}
\alias{codon_mimic}
\alias{codon_mimic,regioned_dna,vector-method}
\alias{codon_mimic,regioned_dna,DNAStringSet-method}
\alias{codon_mimic,DNAStringSet,DNAStringSet-method}
\title{Mimic a target codon usage bias}
\usage{
codon_mimic(object, alt, numcode = 1, ...)

\S4method{codon_mimic}{regioned_dna,vector}(object, alt, numcode)

\S4method{codon_mimic}{regioned_dna,DNAStringSet}(object, alt, numcode)

\S4method{codon_mimic}{DNAStringSet,DNAStringSet}(object, alt, numcode)
}
\arguments{
\item{object}{regioned_dna object}

\item{alt}{target codon usage vector or DNAStringSet object representing
target codon usage}

\item{numcode}{The ncbi genetic code number for translation. Default value: \code{1}. Details please refer to \code{?seqinr::translate} ("https://rdrr.io/cran/seqinr/man/translate.html").}

\item{...}{...}
}
\value{
regioned_dna
}
\description{
Mutating the current DNA sequences in the regioned_dna object to mimic a
target codon usage pattern.
}
\details{
The ideas for \code{codon_mimic} is similar to
  \code{\link{codon_to}}: first extract the mutable regions and then do the
  mutation. However the codons in the fixed (not mutable) regions will also
  alter the final codon usage, thus we have to adjust for the fixed codons
  when introducing sysnonymous codons. The ideal deisgn for
  \code{codon_mimic} is not unique as the swap between positions of the
  synonymous codons will not change the codon usage bias.

  Details pleas refer to: https://koohoko.github.io/SynMut/algorithm.html
}
\examples{
filepath <- system.file("extdata", "example.fasta", package = "SynMut")
rgd.seq <- input_seq(filepath)
target <- get_cu(rgd.seq)[2,]
new <- codon_mimic(rgd.seq, alt = target)
get_cu(new) - get_cu(rgd.seq)

target <- Biostrings::DNAStringSet("TTGAAAA-CTC-N--AAG")
new <- codon_mimic(rgd.seq, alt = target)
get_cu(new) - get_cu(rgd.seq)
get_freq(new) - get_freq(rgd.seq)
get_rscu(new) - get_rscu(rgd.seq)
}
\seealso{
\code{\link{input_seq}}, \code{\link{codon_to}},
  \code{\link{codon_random}}, \code{\link{dinu_to}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/regioned_dna_Class.R
\name{get_region}
\alias{get_region}
\alias{get_region,regioned_dna-method}
\title{Get the variable region}
\usage{
get_region(object, ...)

\S4method{get_region}{regioned_dna}(object)
}
\arguments{
\item{object}{regioned_dna}

\item{...}{...}
}
\value{
list
}
\description{
Access the variable regions
}
\examples{
filepath <- system.file("extdata", "example.fasta", package = "SynMut")
rgd.seq <- input_seq(filepath)
get_region(rgd.seq)
}
\seealso{
\code{\link{input_seq}}, \code{\link{get_cu}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/codon_random.R
\name{codon_random}
\alias{codon_random}
\alias{codon_random,regioned_dna-method}
\alias{codon_random,DNAStringSet-method}
\title{Generate random synonymous mutations}
\usage{
codon_random(object, n = 1, keep = FALSE, numcode = 1, ...)

\S4method{codon_random}{regioned_dna}(object, n, keep, numcode)

\S4method{codon_random}{DNAStringSet}(object, n, keep, numcode)
}
\arguments{
\item{object}{A regioned_dna object.}

\item{n}{Optional n parameter specifying what proportion of the codons to be
mutated. Default value: \code{1}.}

\item{keep}{Logical parameter controling whether keeping the codon usage bias}

\item{numcode}{The ncbi genetic code number for translation. Default value: \code{1}. Details please refer to \code{?seqinr::translate} ("https://rdrr.io/cran/seqinr/man/translate.html").}

\item{...}{...}
}
\value{
A regioned_dna object containing the mutants; Or a DNAStringSet
  object if the input is a DNAStringSet object.
}
\description{
Generating random synonymous mutations (in user-defined region), with
optionally keeping/not keeping the original codon usage bias.
}
\details{
This method randomly sample synonymous codons for \code{n} propotion
  of every mutable codons in the sequences. This process will be likely to
  alter the codon usage bias of the original sequences. However the
  \code{keep = TRUE} argument help to preserve the codon usage bias. It is
  done via the \code{synsequence} function in \code{seqinr} package. The
  \code{synsequence} function essentially swaps the position of the
  synonymous codons without introducing new codons into the original
  sequences.
}
\examples{
filepath <- system.file("extdata", "example.fasta", package = "SynMut")
rgd.seq <- input_seq(filepath)
set.seed(2019)
get_cu(codon_random(rgd.seq, n = 0.5))
get_cu(codon_random(rgd.seq))
}
\seealso{
\code{\link{input_seq}}, \code{\link{dinu_to}},
  \code{\link{codon_to}}, \code{\link{codon_mimic}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/distance_analysis.R
\name{codon_dist}
\alias{codon_dist}
\alias{codon_dist,ANY-method}
\title{Calculating the codon usage difference between sequences}
\usage{
codon_dist(seq, ref)

\S4method{codon_dist}{ANY}(seq, ref)
}
\arguments{
\item{seq}{the input DNA sequnece of \code{DNAStringSet} or
\code{regioned_dna} class.}

\item{ref}{the reference DNA sequnece of \code{DNAStringSet} or
\code{regioned_dna} class.}
}
\value{
vector
}
\description{
We use a least squares approach to estimate the codon usage
difference between DNA sequences.
}
\details{
idea inspired by "Daniel Macedo de Melo Jorge, Ryan E.
  Mills, Adam S. Lauring, CodonShuffle: a tool for generating and analyzing
  synonymously mutated sequences, Virus Evolution, Volume 1, Issue 1, March
  2015, vev012, https://doi.org/10.1093/ve/vev012"
}
\examples{
filepath <- system.file("extdata", "example.fasta", package = "SynMut")
rgd.seq <- input_seq(filepath)
get_cu(rgd.seq)

mut.seq <- codon_random(rgd.seq)
codon_dist(mut.seq, rgd.seq)
mut.seq2 <- codon_random(rgd.seq, keep = TRUE)
codon_dist(mut.seq2, rgd.seq)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dinu_to.R
\name{dinu_to}
\alias{dinu_to}
\alias{dinu_to,regioned_dna-method}
\title{Maximize or minimize the usage of certain dinucleotide.}
\usage{
dinu_to(object, max.dinu = NA, min.dinu = NA, keep = FALSE, numcode = 1, ...)

\S4method{dinu_to}{regioned_dna}(object, max.dinu, min.dinu, keep, numcode)
}
\arguments{
\item{object}{A regioned_dna object.}

\item{max.dinu}{A string of a dinucleotide.}

\item{min.dinu}{A string of a dinucleotide.}

\item{keep}{A logical varibale stating if the codon usage of the original
sequences should be keep. Default: False.}

\item{numcode}{The ncbi genetic code number for translation. Default value: \code{1}. Details please refer to \code{?seqinr::translate} ("https://rdrr.io/cran/seqinr/man/translate.html").}

\item{...}{...}
}
\value{
regioned_dna
}
\description{
Input string of a dinucleotide to either the "max.dinu = " or "min.codon = "
parameter to maximize or minimize the usage of certain codon in the sequence.
Using a greedy algorithm with priority given to dinucleotide12 or
dinucleotide23.
}
\details{
The detail strategy for this function please refer to:
https://koohoko.github.io/SynMut/algorithm.html
}
\examples{
filepath <- system.file("extdata", "example.fasta", package = "SynMut")
rgd.seq <- input_seq(filepath)
get_du(dinu_to(rgd.seq, max.dinu = "cg")) - get_du(rgd.seq)
get_du(dinu_to(rgd.seq, min.dinu = "AA")) - get_du(rgd.seq)
get_du(dinu_to(rgd.seq, max.dinu = "cg", keep = TRUE)) - get_du(rgd.seq)
get_cu(dinu_to(rgd.seq, max.dinu = "CG", keep = TRUE)) - get_cu(rgd.seq)
}
\seealso{
\code{\link{input_seq}}, \code{\link{codon_to}},
  \code{\link{codon_random}}, \code{\link{codon_mimic}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/seq_random.R
\name{seq_random}
\alias{seq_random}
\alias{seq_random,numeric,numeric-method}
\title{Generate \code{n} random DNA sequnces of length \code{m}}
\usage{
seq_random(n = 1, m, no.stop.codon = FALSE, ...)

\S4method{seq_random}{numeric,numeric}(n, m, no.stop.codon)
}
\arguments{
\item{n}{the number of the output sequence(s).}

\item{m}{the length of the ouput sequence(s). Eighter a fixed number or a
vector of different numbers.}

\item{no.stop.codon}{Default FALSE. If TRUE, the stop codons in the frame 1
would be substituted to another random codon.}

\item{...}{...}
}
\value{
a DNAStringSet object
}
\description{
Generate \code{n} random DNA sequnces of length \code{m}, optional exclude
stop codons.
}
\examples{
seq_random(n = 1, m = 99)
seq_random(n = 10, m = 30)
seq_random(n = 10, m = 1:10)
seq.nsc <- seq_random(n = 10, m = 100, no.stop.codon = TRUE)
get_cu(seq.nsc)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/regioned_dna_Class.R
\name{get_freq}
\alias{get_freq}
\alias{get_freq,regioned_dna-method}
\alias{get_freq,DNAStringSet-method}
\alias{get_freq,matrix-method}
\alias{get_freq,vector-method}
\title{Get codon usage frequency of synonymous codons}
\usage{
get_freq(object, numcode = 1, ...)

\S4method{get_freq}{regioned_dna}(object, numcode)

\S4method{get_freq}{DNAStringSet}(object, numcode)

\S4method{get_freq}{matrix}(object, numcode)

\S4method{get_freq}{vector}(object, numcode)
}
\arguments{
\item{object}{regioned_dna / DNAStringSet / codon usage matrix (vector)}

\item{numcode}{The ncbi genetic code number for translation. Default value: \code{1}. Details please refer to \code{?seqinr::translate} ("https://rdrr.io/cran/seqinr/man/translate.html").}

\item{...}{...}
}
\value{
matrix
}
\description{
Access the synonymous codon usage frequency
}
\examples{
filepath <- system.file("extdata", "example.fasta", package = "SynMut")
rgd.seq <- input_seq(filepath)
get_freq(rgd.seq)
}
\seealso{
\code{\link{input_seq}}, \code{\link{get_region}},
  \code{\link{get_cu}}, \code{\link{get_du}}, \code{\link{get_rscu}}
}
